/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/


void processoutgoing(int i) {
char buf[100]; char data[MTU];
int g=0;

/* Are they looking for a file that doesn't exist? */
if (strcasecmp(getreqs[i],"404")==0) {
  send404(i);
  discon(i);
} else


/* If we haven't even opened the file yet, do this: */
if (charsread[i]<0) {
  charsread[i]=0;
  filelen[i]=flength(getreqs[i]);
  filefd[i]=fopen(getreqs[i],"rb");

    senddata(infd[i],"HTTP/1.1 200 OK\n");
    sprintf(buf,"Server: Anti-Web HTTPD V%s (%s)\n",VERSION,COOLQUOTE);
    senddata(infd[i],buf);
    sendcontenttype(i,getreqs[i]);
    sprintf(buf,"Content-Length: %d\n",filelen[i]);
    senddata(infd[i],buf);
    senddata(infd[i],"\n");
} else


/* If we've opened it, we must send them data! */
if (charsread>=0) {

  memset(data,0,MTU);

  for (g=0;((g<=MTU) && (infd[i]!=-1) && (charsread[i]<filelen[i]));g++) {
    charsread[i]++;
    data[g]=fgetc(filefd[i]);
  }

  if (write(infd[i],data,g) == -1) discon(i);
  if (charsread[i]>=filelen[i]) discon(i);

}


}




void send301(int i, char *tpbuf) {

char tpbuf2[MAXDATASIZE];
char tpbuf3[MAXDATASIZE];

strcpy(tpbuf2,tpbuf+strlen(cnfdir));
strcat(tpbuf2,"/");

senddata(infd[i],"<!DOCTYPE HTML PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n<HTML><HEAD>\n<TITLE>301 Moved Permanently</TITLE>\n</HEAD><BODY>\n<H1>Moved Permanently</H1>\n");
sprintf(tpbuf3,"The document has moved <A HREF=\"%s\">here</A>.<P>\n",tpbuf2);
senddata(infd[i],tpbuf3);
senddata(infd[i],"<HR>\n</BODY></HTML>\n");

}




void send404(int i) {

senddata(infd[i],"HTTP/1.0 404 Not Found\n");
senddata(infd[i],"Content-Type: text/html\n\n");
senddata(infd[i],"<HTML><BODY>\n");
senddata(infd[i],"<TITLE>404 Not Found</TITLE>\n");
senddata(infd[i],"<H1>It ain't there, my friend. (404 Not Found)</H1>\n");
senddata(infd[i],"<br><br>\n");
senddata(infd[i],"Anti-Web HTTPD - Take back some simplicity.\n");
senddata(infd[i],"</BODY></HTML>\n");

}

/* Send a 403 Forbidden.  Reason: 1=Busy 2=We don't like you. Fuck off.*/
void send403(int thesock, int reason) {

senddata(thesock,"HTTP/1.0 403 Forbidden\n");
senddata(thesock,"Content-Type: text/html\n\n");
senddata(thesock,"<HTML><BODY>\n");
senddata(thesock,"<TITLE>403 Forbidden</TITLE>\n");

if (reason==1) senddata(thesock,"<H1>Server is full. Try again later. (403 Forbidden)</H1>\n");
if (reason==2) senddata(thesock,"<H1>We don't like you. Fuck off. (403 Forbidden)</H1>\n");

senddata(thesock,"<br><br>\n");
senddata(thesock,"Anti-Web HTTPD - Take back some simplicity.\n");
senddata(thesock,"</BODY></HTML>\n");


}
