/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/


int processincoming(int i, char *buf) {

if (sending[i]==0) {

  if (strncasecmp(buf,"GET",3)==0) {
    stripcrlf(buf);
    sending[i]=1;
    processgetreq(i,buf);
    numofusers++;
    if (infd[i]==-1) return 0; /* In case they got sent a 301... */

#ifndef NOSCRIPT
    /* ---- Ok... if it isn't a 404, is the file a script file? */
    if (strncasecmp(getreqs[i],"404",3)!=0) 
      if (isacgifile(getreqs[i])==1) initscript(i);
#endif

  }


stripcrlf(buf);

}
return 0;
}


int processgetreq(int i, char *buf) {

int g;
char tpbuf[MAXGETREQSIZE+MAXROOTDIRSIZE+10];
char junkbuf[(strlen(HIDDENPREFIX)+2)];

buf=buf+4;

for(g=0;g<=strlen(buf);g++)
  if (buf[g]==SPACE) buf[g]=0;


/* The function now does a few cool things.
   It checks to make sure the user's browser sent along a valid GET
   request, and if not, parse it acceptably, then check that the user
   isn't trying anything funny by including ~ or .. or anything. Then
   it checks to see the the file doesn't start with HIDDENPREFIX, then
   check if the file actually exists. If not, it puts "404" into buf,
   if so, it will put a correctly parsed filename into buf. */


strcpy(tpbuf,cnfdir);

if (buf[0]!=SLASH) strcat(tpbuf,"/");
strncat(tpbuf,buf,MAXGETREQSIZE-1);

#ifdef URLDECODE
  urldecode(tpbuf);
#endif

/* ---- UH OH! You naughty SOB! You triggered the security patch!
   Trying to view "/../../../etc/passwd" or something, hm? 
   Sucker! We'll 404 your ass!!!!! */
for (g=0;g<strlen(tpbuf)-1;g++) {
   if ((tpbuf[g]==POINT) && (tpbuf[g+1]==POINT)) { /* For security (No ".."s) */
      strcpy(getreqs[i],"404"); return 0;
   }
   if (HIDEFILESSTARTINGWITHADOT==1) { /* Security patch (No "/."s */
     if ((tpbuf[g]==SLASH) && (tpbuf[g+1]==POINT)) {
        strcpy(getreqs[i],"404"); return 0;
     }
   }
}

/* ---- Does file start with HIDDENPREFIX? If so: 404! */

#ifdef HIDDENPREFIX
  strcpy(junkbuf,"/");
  strcat(junkbuf,HIDDENPREFIX);
  
  if (strstr(tpbuf,junkbuf)!=NULL) {
    strcpy(getreqs[i],"404"); return 0;
  }
#endif


/* ---- So? Does all this mess find us the right file? 
        BTW - Check to make sure it isn't a directory... */
if ((doesfileexist(tpbuf)==1) && (isadir(tpbuf)==0)) {
               strcpy(getreqs[i],tpbuf); return 0;        }


/* ---- Ok... If it is a directory but doesn't end with a /, send a 301 */
if ((tpbuf[strlen(tpbuf)-1]!=SLASH) && (isadir(tpbuf)==1)) {
send301(i,tpbuf);
discon(i);
return 0;
}


/* ---- No? How 'bout this? */
if (tpbuf[strlen(tpbuf)-1]!=SLASH) strcat(tpbuf,"/");
strcat(tpbuf,INDEXFILE);
if (doesfileexist(tpbuf)==1) {
               strcpy(getreqs[i],tpbuf); return 0;        }


/* ---- Looks like you fucked up... 404, dude. */
strcpy(getreqs[i],"404");
return 0;



}
